rem ************************************************************
rem   RZ-Tool zur Zeichnungsuntersttzung bei der Entwicklung
rem   von Rizeichnungen und Datenblttern (fr CorelDraw9)
rem
rem   Author:   Oliver Johanndrees            28.05.1999
rem ************************************************************
REM Updated to DRAW 9 format by CSCConv 9.0


DIM ObjType AS LONG	 ' The currently selected object type.
DECLARE SUB Zylinder (a&)

WithObject "CorelDRAW.Automation.9"
rem On Error goto Fehler

BEGIN DIALOG RZCD 0, 0, 94, 204, "RZ-Tool  V1.6"
	PUSHBUTTON  6, 10, 37, 14, "0,10 mm"
	PUSHBUTTON  6, 28, 38, 15, "0,13 mm"
	PUSHBUTTON  6, 46, 38, 14, "0,18 mm"
	PUSHBUTTON  6, 64, 38, 14, "0,25 mm"
	PUSHBUTTON  6, 82, 38, 15, "0,35 mm"
	PUSHBUTTON  6, 100, 38, 15, "0,50 mm"
	PUSHBUTTON  6, 118, 38, 14, "0,70 mm"
	PUSHBUTTON  6, 147, 38, 14, "120 Grad"
	GROUPBOX  2, 0, 46, 137, "Strichstrke"
	GROUPBOX  2, 137, 46, 27, "Rotation"
	PUSHBUTTON  51, 9, 37, 14, "30"
	GROUPBOX  47, 0, 46, 96, "Isometrie"
	PUSHBUTTON  51, 25, 37, 15, "35"
	PUSHBUTTON  51, 43, 37, 14, "40"
	PUSHBUTTON  51, 59, 37, 14, "50"
	PUSHBUTTON  51, 76, 37, 15, "60"
	GROUPBOX  47, 91, 46, 46, "Dimetrie"
	PUSHBUTTON  51, 100, 37, 15, "7"
	PUSHBUTTON  51, 118, 37, 14, "42"
	PUSHBUTTON  52, 147, 36, 14, "erstellen"	 'Zylinder erstellen
	GROUPBOX  46, 137, 47, 27, "Zylinder"
	TEXT  6, 194, 84, 8, "(c) 1999  O. Johanndrees"
	GROUPBOX  2, 164, 91, 28, "In isometrisch"
	PUSHBUTTON  7, 173, 81, 15, "umwandeln"
END DIALOG


rem ************************************************************
rem            Script-Dialog auswerten und Handling
rem ************************************************************

Model& = 2
ende%  = 0
while ende% = 0
  kontrolle = Dialog (RZCD)
  if kontrolle = 2 then stop
  if kontrolle < 10 then
    SELECT CASE kontrolle
      CASE 3
        Staerke& = 1000
      CASE 4
        Staerke& = 1300
      CASE 5
        Staerke& = 1800
      CASE 6
        Staerke& = 2500
      CASE 7
        Staerke& = 3500
      CASE 8
        Staerke& = 5000
      CASE 9
        Staerke& = 7000
    END SELECT

rem     objType& = .GetObjectType()
rem     IF (ObjType& <= DRAW_OBJECT_TYPE_RESERVED) THEN
rem       Exit
rem     ENDIF
rem     if objType& < 12 then .GetOutlineColor Model&, C1&, C2&, C3&, C4&

     .ApplyOutline Staerke&, 1, 1, 1, 100, 0, 0, 0, 0, 0
rem 	.StoreColor Model&, 100, 100, 100, 0, 0, 0, 0, 0
rem 	.SetOutlineColor 
rem     if objType& < 12 then .SetOutlineColor Model&, C1&, C2&, C3&, C4&
    ende = 1  
  elseif kontrolle = 10 then
    .RotateObject 120000000, -1, 0, 0
  elseif kontrolle > 10 and kontrolle < 18 then
    .CreateEllipse -150000, -150000, 150000, 150000, 0, 0, 0
    .AlignToCenterOfPage 3, 3
    .ApplyOutline 1800, 1, 1, 1, 100, 0, 0, 0, 0, 0
    SELECT CASE kontrolle
      CASE 11
        Groesse! =  1.74
      CASE 12
        Groesse! =  1.65
      CASE 13
        Groesse! =  1.56
      CASE 14
        Groesse! =  1.31
      CASE 15
        Groesse! =  1.15
      CASE 16
        Groesse! =  3.0
      CASE 17
        Groesse! =  1.13
    END SELECT
    stat& = .GetSize (XSize&, YSize&)
    .SetSize XSize&, YSize& / Groesse!
    ende = 1  
  elseif kontrolle = 18 then
    call Zylinder (a&)
  elseif kontrolle = 19 then
    .RotateObject 45000000, -1, 0, 0
    stat& = .GetSize (XSize&, YSize&)
    .SetSize XSize&, YSize& / 1.74
    ende = 1  
  endif
wend
stop
End WithObject

Fehler:
retval% = MessageBox("Es ist kein Objekt markiert !", "ACHTUNG", 0 + 48)
stop


rem ************************************************************
rem            Unterprogramm  "Zylindererstellung"
rem ************************************************************

SUB Zylinder (a&)

  WithObject "CorelDRAW.Automation.9"
rem  On Error goto Fehler2

  Y&       = 150000
  X&       = 120000
  durchm%  = 10
  z_hoehe% = 40
  fuellen% = 0


  BEGIN DIALOG Dialogfeld1 98, 126, "Zylinder V1.0"
     OPTIONGROUP fuellen%
		OPTIONBUTTON  13, 56, 58, 11, "Flche fllen"
		OPTIONBUTTON  13, 66, 58, 11, "nicht  fllen"
	SPINCONTROL  12, 11, 50, 12, durchm%
	SPINCONTROL  12, 35, 50, 11, z_hoehe%
	TEXT  68, 13, 12, 8, ""
	TEXT  67, 35, 21, 9, "Hhe"
	GROUPBOX  5, 1, 87, 81, ""
	PUSHBUTTON  28, 88, 46, 14, "Ok"
	PUSHBUTTON  28, 108, 46, 14, "Abbruch"
  END DIALOG

  ret    = DIALOG(Dialogfeld1)
  if ret = 4 then stop

  breite# = durchm%  *  10000
  hoehe#  = z_hoehe% * -10000

  rem Die Ellipsenfnung wird hier fr 30-Isometrie eingestellt
  E_hoehe#   = breite# / 1.74
  E_versatz# = E_hoehe# / 2

  .CreateRectangle Y&, X&, Y&+hoehe#, X&+breite#, 0
  ID_Rechteck& = .GetObjectsCDRStaticID()
  .CreateEllipse Y&-E_versatz#, X&, Y&+E_versatz#, X&+breite#, 0, 0, 0
  ID_Ellipse1& = .GetObjectsCDRStaticID()
  .CreateEllipse Y&+hoehe#-E_versatz#, X&, Y&+hoehe#+E_versatz#, X&+breite#, 0, 0, 0
  ID_Ellipse2& = .GetObjectsCDRStaticID()

  .SelectObjectOfCDRStaticID ID_Rechteck&
  .AppendObjectToSelection   ID_Ellipse1&
  .AppendObjectToSelection   ID_Ellipse2&
  .Weld
  .ApplyOutline 2500, 1, 1, 1, 100, 0, 0, 0, 0, 0

  Model& = 2
  if fuellen = 0 then 
    .StoreColor Model&, 0, 0, 0, 0, 0, 0, 0, 0
    .ApplyUniformFillColor 
  endif
  ID_Zylinder& = .GetObjectsCDRStaticID()

  .CreateEllipse Y&-E_versatz#, X&, Y&+E_versatz#, X&+breite#, 0, 0, 0
  .ApplyOutline 1300, 1, 1, 1, 100, 0, 0, 0, 0, 0
  .AppendObjectToSelection ID_Zylinder&

  .Group
  .AlignToCenterOfPage 3, 3

  stop
  END WITHOBJECT

  Fehler2:
  retval% = MessageBox("Es ist ein Fehler in der Zylinder-Unterroutine aufgetreten !", "ACHTUNG", 0 + 48)
  stop

END SUB
